% Copyright  2009 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.



function [p, r]=fit_quad_wafer_shape(x, y, data, wafer_func);

m(:,1)=x.^2;
m(:,2)=y.^2;
m(:,3)=x.*y;
m(:,4)=x;
m(:,5)=y;
m(:,6)=1;

p = pinv(m)*data';
r = data - wafer_func(p, [x;y]);


% v=[x;y];
% % p0(1:6)=0;
% p0=[1e-5, 13-5, 0, 0, 0, 0];
% % lb=[0,   0,   -inf, -inf, -inf, -inf];
% % ub=[inf, inf,  inf,  inf,  inf,  inf];
% 
% lb=[ 0  ,  0  , -inf, -inf, -inf,  0  ];
% ub=[ inf,  inf,  inf,  inf,  inf,  inf];
% 
% options=optimset('MaxFunEvals', 1e7);
% 
% [p, r]=lsqcurvefit(wafer_func, p0, v, data, lb, ub, options);



